#!/bin/sh
#/*
# * Project: ClusterControl
# * Version: 2.0
# * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
# * Date   :
# * Description: File for starting and stopping daemon on clients
# */
DAEMON_PATH="/usr/local/bioinf/cc_monitor"
BASE_DIR="/home/apache/clustercontrol/nodeconfig"
#
#
#
DAEMON_NAME="mon_s"
#
#
#
HOSTNAME=`/bin/hostname`
IPADDR=`/sbin/ifconfig | grep "inet addr:" | head -1| cut -d ":" -f 2 | cut -d " " -f 1 `
FILENAME="$BASE_DIR/node-$IPADDR"
#
#
#
register_at_master() {
  echo "<------  NETWORK INFO ------->" > $FILENAME
  /sbin/ifconfig >> $FILENAME
  echo -e "<------  CPU INFO ------->\n" >> $FILENAME
  cat /proc/cpuinfo >> $FILENAME
}
#
#
#
unregister_at_master() {
  rm -f $FILENAME
}

# See how we were called.
case "$1" in
  start)
	#
	# Monitoringtool
	#
        echo -n "Starting ClusterControlMonitor: "
	$DAEMON_PATH/$DAEMON_NAME
	if [ "$?" -eq 0 ]; then 
   	   echo "Done"
	else
   	   echo "Failed"
	   exit
	fi
	register_at_master
        ;;
  stop)
	echo -n "Shutting down ClusterControlMonitor: "
	killall -TERM $DAEMON_NAME
	if [ "$?" -eq 0 ]; then 
   	   echo "Done"
	else
   	   echo "Failed"	
	   exit
	fi
	unregister_at_master
	;;
  restart)
	$0 stop
	$0 start
	;;
  *)
	echo "Usage: $0 {start|stop|restart}"
	exit 1
esac

exit 0
