/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description: Utilities      
 */
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <unistd.h>
#include "defines.h"
#include "network.h"
#include "utils.h"
#include <string.h>

extern int server_socket;

void initServerConnection(struct sockaddr_in *server_address)
{
  memset(server_address, 0, sizeof(struct sockaddr_in));
  server_address->sin_family = AF_INET;
  server_address->sin_port = htons(SERVER_PORT); 
  server_address->sin_addr.s_addr = INADDR_ANY; 
  setHostname();
}


void connectServerSocket(struct sockaddr_in *server_address)
{
  int    error_value;
  server_socket = socket(AF_INET, SOCK_STREAM, 0);
  if (server_socket < 0) 
  {
    writeLogMessage("Error: Opening Server Socket");
    exit (1);
  }

  // Binding ServerSocket
  error_value = bind(server_socket, (struct sockaddr *)server_address, sizeof(struct sockaddr_in));
  if (error_value < 0) 
  {
    writeLogMessage("Error: Binding Server Socket");
    exit (2);
  }
  
  // Listening on ServerSocket, allowing 10 connections
  error_value = listen(server_socket, 10);
  if (error_value < 0) 
  {
    writeLogMessage("Error: Listening on Server Socket");
    exit (3);
  }
}


int addClientSocket(fd_set *open_sockets)
{
  int    new_client_socket;
  int    client_address_size;
  struct sockaddr_in client_address;
  client_address_size=sizeof(struct sockaddr);
  new_client_socket=accept(server_socket,(struct sockaddr *)&client_address, &client_address_size);
  if (new_client_socket < 0)
  {
    return 1;
  }
  FD_SET(new_client_socket, open_sockets);  
  return new_client_socket;
}
