/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :     
 * Description: Utilities
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "defines.h"
#include "utils.h"
extern char *hostname;

int readLineFromFile(char *filename, char *line , int line_number)
{
  FILE *file_to_read;
  char *pos;
  int counter=1;
  memset(line, 0, strlen(line));
  
  if (line_number <=0) return 1;
  file_to_read=fopen(filename,"r"); 
  if (file_to_read==NULL) return 2;

  while ( ! feof(file_to_read) )
  {
    fgets(line, INPUT_BUFFER_LENGTH , file_to_read);
    pos=line;
    while (*pos++) 
    {
      if (*pos == (char)10) *pos=(char)0;
    }  
    if (counter>=line_number) 
     {
       fclose(file_to_read);
       return 0;
     }
    else
      counter++;
  }
  fclose(file_to_read);
  return 3;
}

char *getString()
{
  char *newstring;
  newstring=malloc((sizeof(char))*INPUT_BUFFER_LENGTH);
  memset( newstring, 0, INPUT_BUFFER_LENGTH );
  return newstring;
}


void writeLogMessage(char *message)
{ 

#ifdef DEBUG
  if (DAEMON)
  {
    FILE* debug_file;
    debug_file=fopen( LOG_FILE, "a+");
    fprintf(debug_file, "%s\n", message);
    fclose(debug_file); 
  }
  else
  {
    printf("%s\n", message );
  }
#endif

}



void setHostname()
{
  hostname=getString();
  readLineFromFile("/proc/sys/kernel/hostname", hostname, 1);
  writeLogMessage(hostname);
}

