<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description:
 *   This script implements CLUSTER-Overview functionality, depending at 
 *   the mode variable the appropriate information will be gathered from
 *   the nodes and visualized in an appropriate way.
 *
 */
  require_once("config/main_config.inc.php");
  require_once("inc/authentication_header.php");
  require_once("inc/lib_include.php");
  if (array_key_exists('mode',$_GET))
  {
    $mode = $_GET['mode'];
  }
  else
  {
    $mode="cpu";
  }
  $cluster_view = new cluster();

  if (strcmp($mode,"cpu")==0)
  { 
    $output=new output_class(1,1);
    $cluster_data=$cluster_view->getCPUData();
  }
  elseif (strcmp($mode,"uptime")==0)
  {
    $output=new output_class(0,1);
    $cluster_data=$cluster_view->getUptimeData();  
  }
  elseif (strcmp($mode,"disk")==0)
  {
    $output=new output_class(0,1);
    $cluster_data=$cluster_view->getDiskData();  
  }  
  elseif (strcmp($mode,"mem")==0)
  {
    $output=new output_class(0,1);
    $cluster_data=$cluster_view->getMemData();  
  }  
  elseif (strcmp($mode,"load")==0)
  {
    $output=new output_class(0,1);
    $cluster_data=$cluster_view->getLoadData();  
  }  
  
  if ( $cluster_data ) $cluster_keys=array_keys($cluster_data);
  
  $mode_display_array = array ( 
           "mem"  =>"Memory", 
	   "cpu"  =>"CPU",
	   "load" =>"Load",
	   "uptime" => "Uptime",
	   "disk" => "Disk",
	   );
  
?>

<html>
<head>
   <META http-equiv="refresh" content="60;url=cluster_info.php?mode=<?php echo "$mode"; ?>">
   <meta http-equiv="Content-Style-Type" content="text/css">
   <link REL="STYLESHEET" HREF="Genome.css" type="text/css">
</head>
<body bgcolor="#FFFFFF" text="#000000" vlink="#999999" alink="#999999" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr>
    <td height="30" width="30" valign="top"></td>
  </tr>
  <tr>
    <td width="100%" valign="top" align=center>
        <br>
        <table width="500" border="0" cellspacing="1" class="StandardTable" border=1>
         <tr>
           <td colspan="2" class="StandardTableHead"><?php echo $mode_display_array[$mode]; ?>:</td>
         </tr>
         <tr>
           <td width="649" class="StandardTableCellOdd" align=center> 

<?php
// echo "<hr>MODE: $mode <hr>\n";
 echo "<table border=\"0\"><tr><td align=left valign=0>";
 if ($cluster_data)
 {
     if (strcmp($mode,"cpu")==0)
     { 
       echo " <img src=\"png/cpu.png\" alt=$mode> </td><td>";  
       echo "<table border=0 cellpadding=2 cellspacing=2>";
       echo "<tr><td align=center>Node</td><td align=center>CPU 1</td><td align=center>CPU 2</td></tr>\n";
     }
     elseif (strcmp($mode,"uptime")==0)
     {
       echo " <img src=\"png/karm.png\" alt=$mode> </td><td>";  
       echo "<table border=0 cellpadding=2 cellspacing=2>";
       echo "<tr><td align=center>Node</td><td align=center>Days</td><td align=center>Hours</td><td align=center>Minutes</td><td align=center>Seconds</td></tr>\n";
     }
     elseif (strcmp($mode,"disk")==0)
     {
       echo " <img src=\"png/hdd.png\" alt=$mode> </td><td>";  
       echo "<table border=0 cellpadding=2 cellspacing=2>";
       echo "<tr><td align=center>Node</td><td align=center>Usage</td></tr>\n";
     }
     elseif (strcmp($mode,"load")==0)
     {
       echo " <img src=\"png/xload.png\" alt=$mode> </td><td>";  
       echo "<table border=0 cellpadding=2 cellspacing=2>";
       echo "<tr>
             <td align=center>Node</td>
             <td align=center>&nbsp;</td>
	     <td align=center>1 Min </td>
	     <td align=center>5 Min </td>
	     <td align=center>10 Min </td>
	     </tr>\n";
     }
     elseif (strcmp($mode,"mem")==0)
     {
       echo " <img src=\"png/memory.png\" alt=$mode> </td><td>";  
       echo "<table border=0 cellpadding=2 cellspacing=2>";
       echo "<tr><td align=center>Node</td><td align=center>Mem Usage</td></tr>\n";
     }
      
   foreach ($cluster_keys as $key)
   {
     $data=$cluster_data["$key"];
     $hostname_num=explode(".", $key);

     if (strcmp($mode,"cpu")==0)
     {    
       $output->printCPUStatus($data,$key);
     }
     elseif (strcmp($mode,"uptime")==0)
     {
      printf("<tr><td>%s%d</td>", $config['NODENAME_PREFIX'],($hostname_num[3]-$config['IP_OFFSET'])); 
      $output->printUptimeStatus($data);
      echo "</tr>\n";
     }
     elseif (strcmp($mode,"disk")==0)
     {
       printf("<tr><td valign=top>%s%d</td><td>", $config['NODENAME_PREFIX'],($hostname_num[3]-$config['IP_OFFSET']));
       $output->printDiskStatus($data);
       echo "</td></tr>\n";
     }
     elseif (strcmp($mode,"load")==0)
     {
      printf("<tr><td>%s%d</td><td>", $config['NODENAME_PREFIX'],($hostname_num[3]-$config['IP_OFFSET']));
      $output->printLoadStatus($data);
      echo "</td></tr>\n";
     }
     elseif (strcmp($mode,"mem")==0)
     {
      printf("<tr><td>%s%d</td><td>", $config['NODENAME_PREFIX'],($hostname_num[3]-$config['IP_OFFSET'])); 
      $output->printMemStatus($data);
      echo "</td></tr>\n";
     }
   }
   
   echo "</table>";
   echo "</td></td></table>";
 }
?>        </td>
         </tr>
        </table>
     </td>
  </tr>
</table>
</body>
</html>
