<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Authors: Gernot Stocker, gernot.stocker@tugraz.at
 *          Dietmar Rieder, dietmar.reider@tugraz.at
 * Date   :
 * Description
 */
 

  ###############################################################################
  #
  # PATH CONFIGURATION SECTION
  #
  ###############################################################################

  $config = array();

  #
  # Main path, where the webinterface of clustercontrol is locates in the 
  # system. 
  #
  $config['MONITOR_PATH_'] = "/var/www/html/clustercontrol-2.0";

  #
  # Default URL, must be replaced by the URL under which the ClusterControl is reachable
  #
  $config['DEFAULT_URL']         = "https://<YOUR-SERVER-NAME>/clustercontrol-2.0";


  #
  # Derived paths, don't change them
  #
  $config['CONFIG_PATH_']        = $config['MONITOR_PATH_'] . "/config"; 
  $config['LIB_PATH_']           = $config['MONITOR_PATH_'] . "/lib";
  $config['INC_PATH_']           = $config['MONITOR_PATH_'] . "/inc";


  ###############################################################################
  #
  # AUTHENTICATION CONFIGURATION SECTION
  #
  ###############################################################################

  #
  # File for the file based user identification, make shure, that this file can not 
  # directly be read by a webuser (see details for changes of this file in README)
  #
  $config['PASSWD_FILE']     = $config['MONITOR_PATH_'] . "/config/passwd";
  
  #
  # User that are allowed to do amdinistrative things (adding/deleting/listing of users int the passwd file)
  #
  $config['ADMIN_USER']      = "admin";
  
  #
  # Switch LDAP Authentication on/off == true/false
  #
  $config['LDAP_AUTH'] = false;

  #
  # LDAP Authentication Server, if LDAP is in use
  #
  $config['LDAP_SERVER']     = "localhost";
  
  #
  # Context in the Ldap Server, if LDAP is in use
  #
  $config['LDAP_CONTEXT']    = "ou=People,ou=cluster,o=tugraz,c=at";




  ###############################################################################
  #
  # FUNCTIONAL CONFIGURATION SECTION
  #
  ###############################################################################

  #
  # Disable Node Monitoring (TRUE/FALSE), if you don't want to use the monitoring
  # functionality of clustercontrol
  #
  $config['DISABLE_MONITOR_']       = "FALSE";


  ###############################################################################
  #
  # QUEUE CONFIGURATION SECTION
  #
  ###############################################################################
  #                                     sge/pbs
  $config['queueing_system']          = 'sge';
  #
  # SystemCall Settings for the initial ping, to look whether the node is alive or not
  #
  $config['ping_command_']           = '/bin/ping -c1 -w1 -q';
  


  ###############################################################################
  #
  # PBS CONFIGURATION SECTION
  #
  ###############################################################################
  # include_once($config['MONITOR_PATH_']."/config/pbs_config.inc.php");
  ###############################################################################
  #
  # SGE CONFIGURATION SECTION
  #
  ###############################################################################
  include_once($config['MONITOR_PATH_']."/config/sge_config.inc.php");

  ###############################################################################
  #
  # LOCAL EXECUTION CONFIGURATION SECTION
  #
  ###############################################################################
  include_once($config['MONITOR_PATH_']."/config/local_config.inc.php");

  ###############################################################################
  #
  # CLUSTER CONFIGURATION SECTION FOR THE MONITORING (Skip it if $DISABLE_MONITOR_ = TRUE)
  #
  ###############################################################################
  #
  # NODE Configuration, prefix of the node names which will be extended by a number 
  # e.g. c-001 for node number1
  #
  $config['NODENAME_PREFIX']      = "node-0-";
  
  #
  # Subnet used in the commuication network
  #
  $config['NODEIP_PREFIX']        = "192.168.101";
  #
  # Range of ip's for nodes it can be specified as range from 10-20 or also
  # as islands "12:15:17-20" ... node 12, 15, und 17 bis 20 sind dabei
  #
  $config['CLUSTER_NODES']        = "2-25";
  # Quick Hack don't change it
  $config['IP_OFFSET']            = "2";  
  
  #
  # MONITOR Settings Path where the nodes do their registration during boot up
  #  see in   monitor.sh more details and specify there the same path
  #
  $config['NODE_PATH_']     = "/home/apache/clustercontrol/nodeconfig";
  $config['MONITOR_PORT_']  = "9090";

  ###############################################################################
  #
  # UI SETTINGS SECTION
  #
  ###############################################################################
  $config['BACKGROUND_COLOR']              = "#1908E0";
  
  #
  # Refreshtime during waiting for results
  #
  $config['DEFAULT_REFRESH_TIME']      = "4"; 
  


  ###############################################################################
  #
  # DONT CHANGE BELOW THIS LINE !!!!!!
  #
  ###############################################################################

  
  #
  # MODULES Settings
  #
  $config['MODULE_PATH'] 			= "modules";

  #
  # DebugSettings
  #
  $config['DEBUG_']                  = 0;
  
  #
  # Default Startmode at the beginning:
  # posibilities: cluster, nodes, applications, jobs
  #
  $config['DEFAULT_START_MODE'] 		= "applications";
  
?>
