<?php

 /*
  * Project: ClusterControl
  * Version: 2.0
  * Authors: Gernot Stocker, gernot.stocker@tugraz.at
  *          Dietmar Rieder, dietmar.reider@tugraz.at
  * Date   :
  * Description
  */
 
  ###############################################################################
  #
  # PBS CONFIGURATION SECTION
  #
  ###############################################################################
  #
  # Path to the PBS binaries for jobsubmission and control
  #
  $config['pbs_qsub_command_']       = '/usr/pbs/bin/qsub';
  $config['pbs_qstat_command_']      = '/usr/pbs/bin/qstat';
  $config['pbs_pbsnodes_command_']   = '/usr/pbs/bin/pbsnodes -a';
  #
  # Default queue setting, where to submit the jobs 
  #
  $config['pbs_default_queue_']      = "long@ctrl.cluster.tu-graz.ac.at";        
  #
  # Default setting, how many nodes are used for parallel application if there
  # is nothing specified
  #
  $config['pbs_default_nodes_amount_']      = "7";        
  #
  # Path to the MPICH starting command
  #
  $config['pbs_mpirun_command_']     = '/master/software/mpi/bin/mpirun';
  #
  # Directory where all jobs from the users are stored, EDIT THIS PATH!!!!!!!!
  #
  $config['pbs_jobs_dir_']           = '/home/pbs/pbs-jobs';
  #
  # Shell templates that are used to create the start scripts for the job submission
  # Dont change the PBS specific templates unless you know what you are doing.
  #
  $config['pbs_input_template_']     = $config['INC_PATH_'] . "/pbs_script_template.sh";
  $config['pbs_shell_settings_']     = $config['INC_PATH_'] . "/bashrc.sh";
  
?>
