<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Authors: Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 *          Dietmar Rieder, dietmar.rieder@tugraz.at
 * Date   :
 * Description
 */

/* define some stuff */
define("OK",             10); 
define("USER_EXISTS",    11); 
define("PASSWD_FILE_NX", 12); 
define("PASSWD_FILE_NW", 13); 
define("USER_NX",        14); 


class admin
{
  var $users = array();
  var $passwd_file;

  /*
     Constructor
  */
  function admin()
  {
    global $config;

    $this->passwd_file = $config['PASSWD_FILE'];
  }

  /*

  */

  function check_username($new_user)
  {
    if(eregi("[^a-z0-9]", $new_user))
    {
	return false;
    }
    return true;
  }

  function get_users()
  {
    if (file_exists($this->passwd_file))
    {
	$entries = file($this->passwd_file);
    }
    else
    {
	return PASSWD_FILE_NX;
    }

    foreach($entries as $passwd_line)
    {
	$passwd_array = explode(":", $passwd_line);
	$this->users[] = chop($passwd_array[0]);
    }

    return OK;
  }

  function check_user($username)
  {
    $res = $this->get_users();
    if($res == OK)
    {
	if(in_array($username, $this->users))
	{
	    return OK;
	}
    }

    if($res == PASSWD_FILE_NX)
    {
	return PASSWD_FILE_NX;
    }
    
    return false;
    
  }

  function adduser( $new_user, $new_user_password )
  {
    $res = $this->check_user($new_user);
    if( $res == OK)
    {
	return USER_EXISTS;
    }

    if($res == PASSWD_FILE_NX)
    {
	return PASSWD_FILE_NX;
    }
    
    if (is_writable($this->passwd_file))
    {
	$salt = substr(md5 (uniqid(rand())), 0, 2);
	$entry = $new_user . ":" . crypt($new_user_password, $salt) . "\n";
	$fh = fopen($this->passwd_file, "a");
	flock($fh, LOCK_EX);
	fwrite($fh, $entry);
	flock($fh, LOCK_UN);
	fclose($fh);
    }
    else {
	return PASSWD_FILE_NW;
    }
        
    return true;
    
  }

  function deluser( $del_user )
  {
    $res = $this->check_user($del_user);
    if( $res == false)
    {
	return USER_NX;
    }

    if($res == PASSWD_FILE_NX)
    {
	return PASSWD_FILE_NX;
    }
    
    if (is_writable($this->passwd_file))
    {
	$entries = file($this->passwd_file);

	for($i=0; $i < sizeof($entries); $i++)
	{
	    $user_line = split(':', $entries[$i]);
	    if($user_line[0] == $del_user) {
		unset($entries[$i]);
		break;
	    }
	}
	$data = implode("", $entries);
	$fh = fopen($this->passwd_file, "w");
	flock($fh, LOCK_EX);
	fwrite($fh, $data);
	flock($fh, LOCK_UN);
	fclose($fh);
    }
    else {
	return PASSWD_FILE_NW;
    }
        
    return true;
    
  }
  
}
