<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description
 */

function compareIPS($a, $b)
  {
     $aarray=array();
     $barray=array();
     $aarray=split("\.", trim($a));
     $barray=split("\.", trim($b));
     // echo ("AB: $a:".$aarray[3]."  $b:".$barray[3]." <br>\n");
     if ($aarray[3] == $barray[3]) return 0;
     return ($aarray[3] < $barray[3]) ? -1 : 1;
  }
 

class cluster
{
  var $DEBUG_;
  var $MONITOR_PORT_;
  var $running_nodes_=array();
  var $ping_command_;
  var $nodes_information_=array();
  var $debug_;

  /*
     Constructor
  */
  function cluster()
  {
    global $config;
    // require("config/main_config.inc.php");
    $this->debug_= new debug_class( "cluster" );
    $this->debug_->printDebug ( 7, "Constructor" );    
    $this->MONITOR_PORT_=$config['MONITOR_PORT_'];
    $this->ping_command_=$config['ping_command_'];
    $this->getRunningNodes($config['NODE_PATH_']);
  }

  /*
       Get the list of nodes
  */
  function getNodeList( $node_directory )
  {
    $nodes=array();

    $dir_handle=opendir( $node_directory );
    while ($file = readdir($dir_handle))
    {
      if ($node=strstr($file,"node-"))
      {
        $node_ip = explode ("-",$node);
        $ip=$node_ip[1];
        trim($ip);
        array_push($nodes, $ip);
      }
    }
    closedir($dir_handle);
    sort($nodes);
    return $nodes;
   }

   /*
        Get the list of running nodes
   */
   function getRunningNodes( $node_directory )
   {
     $nodes=array();
     $nodes=$this->getNodeList($node_directory);
     foreach ($nodes as $node)
     {
       exec("$this->ping_command_ $node > /dev/null", $result_array, $result_code);
       if ($result_code==0)
       {
         array_push($this->running_nodes_,$node);
       }
     }
     // print("Path: $node_directory".sizeof($nodes)."] $this->ping_command_ ]");     
    } 

  /*
        Get All CPU DATA
  */
  function getCPUData()
  {
    $this->debug_->printDebug ( 7, "GetCPUData" );  
    $result=array();
    foreach($this->running_nodes_ as $node)
    {
      $connection=new cluster_node_com("$node", $this->MONITOR_PORT_);
      $result[$node]=$connection->getCPUStatus();
    }
    uksort($result, "compareIPS");
    return $result;
  }  

  /*
        Get All UPTIME DATA
  */
  function getUptimeData()
  {
    $this->debug_->printDebug ( 7, "GetUptimeData" );  
    $result=array();
    foreach($this->running_nodes_ as $node)
    {
      $connection=new cluster_node_com("$node", $this->MONITOR_PORT_);
      $result[$node]=$connection->getUptimeStatus();
    }
    uksort($result, "compareIPS");
    return $result;
  }  

  /*
        Get All DISK DATA
  */
  function getDiskData()
  {
    $this->debug_->printDebug ( 7, "GetDiskData" );  
    $result=array();
    foreach($this->running_nodes_ as $node)
    {
      $connection=new cluster_node_com("$node", $this->MONITOR_PORT_);
      $result[$node]=$connection->getDiskStatus();
    }
    uksort($result, "compareIPS");
    return $result;
  }

  /*
        Get All Mem DATA
  */
  function getMemData()
  {
    $this->debug_->printDebug ( 7, "GetMemData" );  
    $result=array();
    foreach($this->running_nodes_ as $node)
    {
      $connection=new cluster_node_com("$node", $this->MONITOR_PORT_);
      $result[$node]=$connection->getMemStatus();
    }
    uksort($result, "compareIPS");
    return $result;
  }

  /*
        Get All Load DATA
  */
  function getLoadData()
  {
    $this->debug_->printDebug ( 7, "GetLoadData" );  
    $result=array();
    foreach($this->running_nodes_ as $node)
    {
      $connection=new cluster_node_com("$node", $this->MONITOR_PORT_);
      $result[$node]=$connection->getLoadStatus();
    };
    uksort($result, "compareIPS");
    return $result;
  }
  
  
}
