<?php 
/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description
 */
class databases_class
{
  var $DataBases_=array();


  function databases_class()
  {
    if (file_exists("conf/databases.conf"))
    {
      $this->readDatabaseFile("conf/databases.conf");
    }
  }
    
  function readDatabaseFile( $filename )
  {
    $database=array();
    $section=array();
    
    if ( $database_file=@file($filename) )
    {
      foreach( $database_file as $line )
      {
        $line=trim($line);
        if ( (! strstr($line, "#")) && $line )
        {
	  $split_array=split(":", $line);
	  
	  $section_name=trim($split_array[0]);

	  $database['name']=trim($split_array[1]);
	  $database['section']=$section;
	  $database['short_name']=trim($split_array[2]);
	  $database['description']=trim($split_array[3]);
	  $database['database_path']=trim($split_array[4]);
	  $database['database_file']=trim($split_array[5]);
	  $db_name=$database['name'];
	  if ( array_key_exists($section_name, $this->DataBases_) )
	  {
	     $section=$this->DataBases_[$section_name];
          }
	  $section[$db_name]=$database;
	  $this->DataBases_[$section_name]=$section;	  
        }
      }
    } 
    else
    {
     echo "<br><blink>NO $filename</blink><br><br>";
    }
  }
  
  function getDatabaseData($database_name)
  {
    $result=array();
    foreach ( array_keys($this->DataBases_) as $section_name )
    {
      $section=$this->DataBases_[$section_name];
      if (isset($section[$database_name]))
      {
        $result[$section_name]=$section[$database_name];
      }
    }
    return $result;
  }

  function getAllDatabaseNames()
  {
    $result=array();
    foreach ( array_keys($this->DataBases_) as $section_name )
    {
      foreach ( array_keys($this->DataBases_[$section_name]) as $db_name )
      {
        array_push($result, $db_name);
      }
    }
    return $result;
  }

  function printDatabases()
  {
    $first=0;
    echo " <table border=0>\n<tr>\n";    
    foreach( array_keys( $this->DataBases_ ) as $section_name )
     {
       echo "<td valign=top><b>".$section_name.":</b>\n";
       $section=$this->DataBases_[$section_name];
       echo "<table border=0 cellpadding=3 cellspacing=0 valign=top>\n";
       $toggle=0;
       foreach( array_keys( $section ) as $db_name )
       {
	 $actual_database=$section[$db_name];
         if ($toggle==0)
	 {
	   if ($first==0)
	   {
             echo " <tr> <td> <input type=\"radio\" name=\"searchdatabases[]\" class=\"Check\" value=\"".$actual_database['name']."\" checked=\"checked\">".$actual_database['name']."</td>";
	     $first=1;
	   }
	   else
             echo " <tr> <td> <input type=\"radio\" name=\"searchdatabases[]\" class=\"Check\" value=\"".$actual_database['name']."\"> ".$actual_database['name']." </td>";
  	   $toggle=1;
         }
	 else
	 {
	   if (isset($actual_database['name']))
	   {
             echo " <td> <input type=\"radio\" name=\"searchdatabases[]\" class=\"Check\" value=\"".$actual_database['name']."\"> ".$actual_database['name']." </td> </tr>\n";
	   }
	   else
	   {
	     echo "<td>&nbsp;</td></tr>\n";
	   }
	   $toggle=0;
	 }	   
       }
       echo "\n</table>\n</td> <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";       
     }
     echo "</tr></table>";
  }
}
?>
