<?php

/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description
 */

class sge_job_class extends basic_job_class
{

  var $jobs_dir_;
  /*
   * General functions for creating a job to run on SGE
   */  
  function sge_job_class( $user )
  {
     $this->basic_constructor_($user,'sge');   
  }

  function postJob()
  {
    $output=array();
    $return_val=0;
    $start_cmd=$this->JOB_["start_file"];
    // TODO: put it into SGE config
    putenv("SGE_ROOT=/opt/gridengine");
    $output=shell_exec("SGE_ROOT=/opt/gridengine ". $this->qsub_command_ . " " . $start_cmd);
    echo "$output";
  }
    
  /*
   * Specificfunctions for normal Jobs
   */
  function writeInputFile( $new_job, $command, $node_amount, $queue)
  {
    $input_template=file($this->input_template_);
    $description="m".$new_job["random"].$new_job["description"];
    $input_file=fopen( $new_job["start_file"], "w");
    $post_processing_command=$this->POST_PROCESSING_COMMAND_;
    if ($input_file)
    {
      foreach($input_template as $line)
      {
        $line=str_replace("##-USERNAME-##",      $this->USER_NAME_, $line);
        $line=str_replace("##-WORKDIRECTORY-##", $new_job["directory_path"], $line);
        $line=str_replace("##-DESCRIPTION-##",   str_replace(" ", "_",(substr($description, 0, 15))), $line);
        $line=str_replace("##-NODES-##",         $node_amount, $line);
        $line=str_replace("##-QUEUENAME-##",     $queue, $line);
        $line=str_replace("##-LOGOUTPUT-##",     $new_job["output_file"], $line);
        $line=str_replace("##-STD_OUTPUTFILE-##",   $new_job["output_file"], $line);
        $line=str_replace("##-QUEUENODES_FILE-##",   $new_job["queue_nodes_file"], $line);
        $line=str_replace("##-ERROROUTPUT-##",   $new_job["error_file"], $line);
        $line=str_replace("##-STD_ERRORFILE-##",   $new_job["error_file"], $line);
        $line=str_replace("##-DONEFILE-##",      $new_job["done_file"], $line);
        $line=str_replace("##-COMMAND-##",       $command, $line);
        if(isset($post_processing_command))
        {
           $line=str_replace("##-POSTPROCESSINGCOMMAND-##", $post_processing_command, $line);
        }
        fwrite($input_file, "$line" );
      }
      // fwrite($input_file,"$command > ".$new_job["output_file"]." 2>&1\n");
      fwrite($input_file,"\ntouch ".$new_job["output_file"]);
      fwrite($input_file,"\ntouch ".$new_job["error_file"]."\n");
    }
	  
  }


}

?>
