<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description
 */

class node_com
{
  
  var $node_ip_;
  var $node_port_;
  var $node_connection_;
  var $error_msg;
  
  var $debug_;
  
  /*
     Constructor
  */
  function node_com($ip, $port)
  {
    $this->node_ip_=$ip;
    $this->node_port_=$port;
    $this->node_connection_= 0;
    $this->debug_= new debug_class( "node_com" );
    $this->debug_->printDebug ( 5, "Init to $this->node_ip_ on $this->node_port_" );
  }
  
  /*
     Connenct to remotehost
  */
  function connect()
  {
    $this->debug_->printDebug(5, "Connecting");
    $this->node_connection_ = fsockopen( $this->node_ip_ , $this->node_port_ , $errno, $errstr);
    if( ($errno != 0) || (!($this->node_connection_)) )
    {
        // $this->debug_->printError("Error while Connecting: ($errno) $errstr");
        return false;
    }
    $line=fgets($this->node_connection_, 1024);
    $this->debug_->printDebug(5, "Connected ($line)");
    return true;
  }

  /*
     Connenct to remotehost
  */
  function isConnected()
  {
    if ( $this->node_connection_ == 0 )
      return false;
    else
      return true;
  }

  /*
     execute command on remotehost
  */
  function executeCommand( $command )
  {
    $end_reached=0;
    $detect_endless_loop=0;
    $results = array();
    $this->debug_->printDebug(5, "Executing ($command)");
    $r = fputs($this->node_connection_,"$command\n");
    while ( $end_reached < 1 )
    {
      $newline=fgets($this->node_connection_, 1024);      
      if ((strstr($newline, "OK")) || (strstr($newline, "NO")))
      {
        $end_reached++;
      }
      else
      {
        if (! strstr($newline, ":>") && (trim($newline)))
        {
	  array_push ($results, trim($newline));
        }
      }
      if ( $detect_endless_loop < 20 )
      {
        $detect_endless_loop++;
      }
      else return(NULL); 
    }
    return($results);    
  }

  /*
     Discconnect
  */
  function disconnect()
  {
    $this->debug_->printDebug(5, "DisConnecting");
    $this->executeCommand("exit");
    if ( $this->node_connection_ ) fclose($this->node_connection_);      
  }
  
  /*
    getNodeIP
  */
  function getNodeIp()
  {
    return($this->node_ip_);
  }  
}
?>
