<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description
 */
 
 function getpossibleNodes($node_string, $nodeip_prefix)
 {
   $possible_nodes=array();
   $ranges=explode(";", $node_string);
   foreach ($ranges as $range)
   {
     if (strstr($range, '-'))
     {
       $borders=explode("-", $range);
       for ($count=$borders[0]; $count <=$borders[1]; $count++)
       {
         array_push($possible_nodes, "$nodeip_prefix.".trim($count));
       }
     }
     else
     {
      if (trim($range))
       array_push($possible_nodes, "$nodeip_prefix.".trim($range));
     }
   }
   return $possible_nodes;
 }

 function printArray( $array )
 { 
   printInternalArray(0, $array );
 }

 function printInternalArray($count, $array )
 { 
  foreach($array as $entry)
   {
     if(is_array($entry))
     {
       printInternalArray(($count+1), $entry);
     }
     else
     {
       for($lauf=0; $lauf<= $count; $lauf++)
       {
         echo "$lauf - ";
       }     
       echo "] $entry<br>\n";
     }
   }
 }

 function printAssArray( $input )
 {
   $line="";
   if (is_array($input))
   {
     $nodeinfo=array_keys ($input);
     foreach ($nodeinfo as $node)
     {
       if (is_array($input[$node]))  
       {
         $line=printAssArray($input[$node]);
       }
       else
       {
         $line= $line."$node: $input[$node] <br>\n";
       }
     }
   }
   else $line="$input <br>\n" ;
   return $line;
 }

function recursiveRMDir ($dirName) 
{ 
  $d = opendir ($dirName); 
  while($entry = readdir($d)) 
  { 
    if ($entry != "." && $entry != ".." && $entry != "") 
    { 
      if (Is_Dir($dirName."/".$entry)) 
      { 
        recursiveRMDir($dirName."/".$entry); 
      } 
      else 
      { 
        UnLink ($dirName."/".$entry); 
      } 
    }  
  } 
  closedir($d); 
  RmDir ($dirName); 
}

?>
