<?php
/*
 * Project: ClusterControl
 * Version: 2.0
 * Author : Gernot Stocker, gernot.stocker@tugraz.at (c) 2006
 * Date   :
 * Description
 */

class view_jobs
{

  var $USER_NAME_;
  var $jobs_dir_;

  function view_jobs($user)
  {
    global $config;
    $this->USER_NAME_=$user;
    $this->jobs_dir_=$config[$config['queueing_system'].'_jobs_dir_'];
  }
  
  function printCurrentJobs($admin)
  {
    global $config;
    $all_jobs=$this->getExistingJobs($admin);

    if ($all_jobs)
    {
     if(!$admin)
     {
       echo "
       
       <form method=post action=\"job_actions.php\"> 
               <input type=hidden name=mul_action value=\"delete_job\">
       ";
       echo "<table border=0 cellspacing=5 cellpadding=1 class=\"StandardTable\">
             <tr>
             <th colspan=2 align=center>jobname</th><th>show result</th><th>show input</th><th>show output</th><th>delete job</th></tr>
       ";
       $counter=0;
       foreach ($all_jobs as $job)
       {
	    if (($counter % 2)==1)
	    {
	        echo "<tr class=\"StandardTableCellEven\" align=left>";
	    }
	    else
	    {
	        echo "<tr class=\"StandardTableCellOdd\" align=left>";
	    }
	    $counter++;	 
	    echo "
                <td align=center><input type=\"checkbox\" name=\"jobs_to_delete[]\" value=\"".urlencode($job["directory_path"])."\"></td>		
                <td>".$job["description"]."</td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=details&dir=".urlencode($job["directory_path"])."\"><img src=\"png/output_file.png\" alt=\"show output\" border=\"0\"></a></td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=show_input&dir=".urlencode($job["directory_path"])."\"><img src=\"png/input_file.png\" alt=\"show input\" border=\"0\"></a></td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=show_queue_output&dir=".urlencode($job["directory_path"])."\"><img src=\"png/q_output.png\" alt=\"show ".$config['queueing_system']." output\" border=\"0\"></a></td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=delete_job&dir=".urlencode($job["directory_path"])."\"><img src=\"png/delete_job.png\" alt=\"delete job\" border=\"0\"></a></td>
	     </tr>
         ";
       }
     }
     else
     {
       echo "
       
       <form method=post action=\"admin_job_actions.php\"> 
               <input type=hidden name=mul_action value=\"delete_job\">
       ";
       echo "<table border=0 cellspacing=5 cellpadding=1 class=\"StandardTable\">
             <tr>
             <th colspan=2 align=center>jobname</th><th>username</th><th>show result</th><th>show input</th><th>show output</th><th>delete job</th></tr>
       ";
       $counter=0;
       foreach ($all_jobs as $job)
       {
	 if (($counter % 2)==0)
	 {
	   echo "<tr class=\"StandardTableCellEven\">";
	 }
	 else
	 {
	   echo "<tr class=\"StandardTableCellOdd\">";
	 }
	 $counter++;
	 echo "
                <td><input type=\"checkbox\" name=\"jobs_to_delete[]\" value=\"".urlencode($job["directory_path"])."\"> </td>
		<td>".$job["description"]."</td>
                <td>".$job["owner"]."</td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=details&dir=".urlencode($job["directory_path"])."\"><img src=\"png/output_file.png\" alt=\"show output\" border=\"0\"></a></td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=show_input&dir=".urlencode($job["directory_path"])."\"><img src=\"png/input_file.png\" alt=\"show input\" border=\"0\"></a></td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=show_queue_output&dir=".urlencode($job["directory_path"])."\"><img src=\"png/q_output.png\" alt=\"show ".$config['queueing_system']." output\" border=\"0\"></a></td>
		<td valign=\"middle\" align=\"center\"><a href=\"job_actions.php?action=delete_job&dir=".urlencode($job["directory_path"])."\"><img src=\"png/delete_job.png\" alt=\"delete job\" border=\"0\"></a></td>
	 </tr>
	     ";
       }
     }
     echo "
     </table>
           <table width=\"300\" border=0>
           <tr class=\"StandardTableCellOdd\">
             <td align=left>
		<input type=\"submit\" value=\"Delete selected\">
	     </td>
	     <td></td>
	     <td align=right>
		<input type=\"reset\" value=\"Cancel\">
	      </td>
	   </tr>
	   </table>
     </form>";
    }
  }
    
  function getExistingJobs($admin)
  {
    $user_jobs=array();    
    if ($jobs = @opendir("$this->jobs_dir_")) 
    {

      if(!$admin)
      {
        while($job_directory = readdir($jobs)) 
        {
          if ( strstr($job_directory, "$this->USER_NAME_"."_") )
	  {
	    $job=$this->readJobDescription("$this->jobs_dir_"."/$job_directory");
	    $user_jobs["$this->jobs_dir_"."/$job_directory"]=$job;
	  }
	}
      }
      else
      {
        while($job_directory = readdir($jobs)) 
        {
          if ( (strcmp($job_directory, '.') != 0) && (strcmp($job_directory, '..') != 0))
	  {
	    $job=$this->readJobDescription("$this->jobs_dir_"."/$job_directory");
	    $user_jobs["$this->jobs_dir_"."/$job_directory"]=$job;
	  }
	}
      }

      closedir($jobs);
    }
    sort($user_jobs);
    
    return $user_jobs;
  }

  
  function readJobDescription( $job_directory )
  {
    $description=array();
    if ( $desc_file=@file("$job_directory"."/description") )
    {
      foreach( $desc_file as $line )
      {
        $line=trim($line);
	if ($line)
	{
	  $line_array=split(":",$line);
	  $key=trim($line_array[0]);
	  $description[$key]=trim($line_array[1]);
	}
      }
    }
    return $description;
  }
  
  function readOutputFile( $job )
  {
    $output_file=array();
    $output_file=@file( $job["output_file"] );
    return $output_file;  
  }

  function readErrorFile( $job )
  {
    $error_file=array();
    $error_file=@file( $job["error_file"] );
    return $error_file;    
  }
  
  function printJob( $job )
  {
    echo "Desc:".$job["description"]."<br>";  
    echo "<hr>OUTPUT<hr><br>\n";
    $res=$this->readOutputFile( $job );
//    echo "<pre>";
    if ($res)
	  {
	    foreach($res as $line)
	    {
	      echo "$line<br>";
	    }
	  }
//    echo "<pre>";
	  
    echo "<hr>ERROR<hr><br>\n";
    $res=$this->readErrorFile( $job );
    if ($res)
    {
      foreach($res as $line)
      {
	echo "$line<br>";
      }
    }
  }
  
  function printJobasText( $job )
  {
    // echo "Job: ".$job["output_file"];
    $content_type = $this->mime_content_type($job["output_file"]);

    if($content_type == "text/html") {
       return $this->printJobasHtml( $job );
    }  
    print "<table width=\"580\" border=\"0\" cellspacing=\"1\" class=\"StandardTable\" border=1>";
    print "<tr>";
    print "<td class=\"StandardTableHead\">";
    echo "Program output: ".$job["description"]."\n";
    print "</td></tr>";  
    $res=$this->readOutputFile( $job );
    print "<tr>";
    print "<td class=\"StandardTableCellOdd\">";
    echo "\n<pre>\n";
    if ($res)
	  {
	    foreach($res as $line)
	    {
	      /*
	       * Quickhack for BLAST grafical View!!!!!!!!!!!!!!!!!! To be corrected
	       */
	      echo "$line";
	      if ( file_exists($job["output_file"].".img.png") && ( strstr($line, "Searching." ) ))
		{
		   print "<br><form>\n";
		   print "<p><H3><CENTER> Distribution of Blast Hits on the Query Sequence</CENTER></H3>\n";
		   print "<p><CENTER><input name=defline size=80 value=\"Mouse-over to show defline and scores. Click to show alignments\"></CENTER>\n";

		   $blast_image_map=file($job["output_file"].".map.txt");
	           foreach($blast_image_map as $blast_image_map_line)
	           {
		     print "$blast_image_map_line";
		   }

                   print "<p><CENTER><img src=\"lib/print_png_from_file.php?filename=".urlencode($job["output_file"]).".img.png\"  border=\"0\" usemap=\"#Alignment_Map\"></CENTER>\n";
	           print "<HR><br><br></form>\n";						 
		}
	    }
	  } else {
		print "The program did not generate an output yet.";
	}
    echo "\n</pre>\n";
    print "</td></tr></table>";
    
    if(file_exists($job["output_image"])) {
          print "<p><img src=\"lib/print_png_from_file.php?filename=".urlencode($job["output_image"])."\"  border=\"0\">\n";
    }
  }

  function printJobasHtml( $job )
  {

    $res=$this->readOutputFile( $job );


    if ($res)
         {
           foreach($res as $line) {
             if(stristr($line, "<img src=\"output.png\">")) {
               print "<p><img src=\"lib/print_png_from_file.php?filename=".urlencode($job["output_image"])."\"  border=\"0\">\n";
             } else {
               echo "$line";
             }
             /*
              * Quickhack for BLAST grafical View!!!!!!!!!!!!!!!!!! To be corrected
              */
             if ( file_exists($job["output_file"].".img.png") && ( strstr($line, "Searching." ) ))
               {
                  print "<br><form>\n";
                  print "<p><H3><CENTER> Distribution of Blast Hits on the Query Sequence</CENTER></H3>\n";
                  print "<p><CENTER><input name=defline size=80 value=\"Mouse-over to show defline and scores. Click to show alignments\"></CENTER>\n";

                  $blast_image_map=file($job["output_file"].".map.txt");
                  foreach($blast_image_map as $blast_image_map_line)
                  {
                    print "$blast_image_map_line";
                  }

                  print "<p><CENTER><img src=\"lib/print_png_from_file.php?filename=".urlencode($job["output_file"]).".img.png\"  border=\"0\" usemap=\"#Alignment_Map\"></CENTER>\n";
                  print "<HR><br><br></form>\n";
               }


           }
	  }
         
/*	 
    if(file_exists($job["output_image"])) {
     print "<p><img src=\"lib/print_png_from_file.php?filename=".urlencode($job["output_image"])."\"  border=\"0\">\n";
   }
*/
  }



  function printPBSOutputasText( $job )
  {
    global $config;
    print "<table width=\"580\" border=\"0\" cellspacing=\"1\" class=\"StandardTable\" border=1>";
    print "<tr>";
    print "<td class=\"StandardTableHead\">";
    print strtoupper($config['queueing_system'])."-OUTPUT: ".$job["description"]."\n";
    print "</td></tr>";
    $res=$this->readPBSOutputFile( $job );
    print "<tr>";
    print "<td class=\"StandardTableCellOdd\">";
    echo "<pre>";
    if ($res)
	  {
	    foreach($res as $line)
	    {
	      echo "$line";
	    }
	  } else {
	    print "None";
	  }
    echo "</pre>";
    print "</td></tr>";
	  
    print "<tr>";
    print "<td class=\"StandardTableHead\">";
    print "Errors:\n";
    print "</td>";
    $res=$this->readErrorFile( $job );
    print "<tr>";
    print "<td class=\"StandardTableCellOdd\">";
    echo "<pre>";
    if ($res)
    {
      foreach($res as $line)
      {
	echo "$line";
      }
    } else {
	print "None";
    }
    echo "</pre>";
    print "</td></tr></table>";
  }

  function readPBSOutputFile( $job )
  {
    $output_file=array();
    $output_file=@file( $job["pbs_output_file"] );
    return $output_file;  
  }

  function printNodes($job)
  {
    print "<table width=\"580\" border=\"0\" cellspacing=\"1\" class=\"StandardTable\" border=1>";
    print "<tr>";
    print "<td class=\"StandardTableHead\">";
    echo "Status of the used node(s):\n";
    print "</td></tr>";
    $nodes=$this->getNodes($job);
    print "<tr>";
    print "<td class=\"StandardTableCellOdd\">";
    echo "<table>";
    if(count($nodes) > 0) {
	foreach( $nodes as $line ) {
    	    echo "<tr valign=\"middle\"><td valign=\"center\" class=\"StandardTableCellOdd\">$line</td><td valign=\"center\" class=\"StandardTableCellOdd\">";
    	    $NodeInfo = new cluster_node_com($line, "9090");
    	    $output = new output_class(1,0);
    	    $result=$NodeInfo->getSystemStatus();
    	    $output->printLoadStatus($result["load"]);
    	    echo "</td>";
	}
    } else {
	echo "<tr><td><pre>No cluster nodes in use</pre></td><td></tr>";
    }
    echo "</table>";
    print "</td></tr>";
    print "</td></tr></table>";

  }

  function getNodes($job)
  {
    $nodes=array();
    if ( $nodes_file=@file($job["queue_nodes_file"]) )
    {
      foreach( $nodes_file as $line )
      {
        array_push($nodes, trim($line));
      }
    }
    return $nodes;
  }
  
  function mime_content_type ($file) 
  {
    return exec ("file -bi " . escapeshellcmd($file));
  }
}

?>
