<?php

  require_once ("../../inc/lib_include_modules.php");

  if (isset($_POST['jobname'])) { $jobname=$_POST['jobname']; }
  if (isset($_POST['searchdatabases'])) { $searchdatabases=$_POST['searchdatabases']; }
  if (isset($_POST['expectationvalue'])) { $expectationvalue=$_POST['expectationvalue']; }
  if (isset($_POST['filter_low_compl'])) { $filter_low_compl=$_POST['filter_low_compl']; }
  if (isset($_POST['filter_hum_rep'])) { $filter_hum_rep=$_POST['filter_hum_rep']; }
  if (isset($_POST['filter_mask_lt'])) { $filter_mask_lt=$_POST['filter_mask_lt']; }
  if (isset($_POST['filter_vec_screen'])) { $filter_vec_screen=$_POST['filter_vec_screen']; }
  if (isset($_POST['LCASE_MASK'])) { $LCASE_MASK=$_POST['LCASE_MASK']; }
  if (isset($_POST['wordsize'])) { $wordsize=$_POST['wordsize']; }
  if (isset($_POST['cutoff_percent'])) { $cutoff_percent=$_POST['cutoff_percent']; }
  if (isset($_POST['nr_descriptions'])) { $nr_descriptions=$_POST['nr_descriptions']; }
  if (isset($_POST['nr_alignments'])) { $nr_alignments=$_POST['nr_alignments']; }
  if (isset($_POST['ALIGNMENT_VIEW'])) { $ALIGNMENT_VIEW=$_POST['ALIGNMENT_VIEW']; }
  if (isset($_POST['OUTPUT_TYPE'])) { $OUTPUT_TYPE=$_POST['OUTPUT_TYPE']; }
  if (isset($_POST['OTHER_ADVANCED'])) { $OTHER_ADVANCED=$_POST['OTHER_ADVANCED']; }

$factory=new run_module_class_factory();
$blast_module=$factory->createRunModuleClass($_SESSION['PHP_AUTH_USER'], "megaBLAST", $jobname);

$blast_module->define_current_program("/usr/local/bioinf/ncbi-blast/megablast","");

$blast_module->process_databases($searchdatabases);
$blast_module->process_sequence_input( 'sequence', $_POST, 'sequence_file', $_FILES );

$blast_module->print_html_header();

$blast_module->add_parameter_to_command("-i", "%Inputfile");
$blast_module->add_parameter_to_command("-d", "%Database");


if ( isset($expectationvalue) && is_numeric($expectationvalue))
   { $blast_module->add_parameter_to_command("-e", $expectationvalue); }


if (isset($filter_low_compl) ||
    isset($filter_hum_rep) ||
    isset($filter_mask_lt) ||
    isset($filter_vec_screen)
   )
   {
    $filter = "";
    $f_count = 0;

    if (isset($filter_low_compl))
    {
      $filter = $filter_low_compl;
      $f_count++;
    }
    
    if (isset($filter_hum_rep))
    {
      if($f_count > 0)
      {
        $filter = $filter . ';' . $filter_hum_rep;
      }
      else
      {
        $filter = $filter_hum_rep;
      }
      $f_count++;
    }
    
    if (isset($filter_vec_screen))
    {
      if($f_count > 0)
      {
        $filter = $filter . ';' . $filter_vec_screen;
      }
      else
      {
        $filter = $filter_vec_screen;
      }
      $f_count++;
    }

    if (isset($filter_mask_lt) && ($f_count > 0)) 
    {
      $filter = "m" . " " . $filter;
    }
    if (isset($filter_mask_lt) && ($f_count == 0)) 
    {
      $filter = "m";
    }

    $blast_module->add_parameter_to_command("-F", $filter);

   }


if ( isset($LCASE_MASK) && (!empty($LCASE_MASK)))
   { $blast_module->add_parameter_to_command("-U", T); }

if ( isset($wordsize) && is_numeric($wordsize))
   { $blast_module->add_parameter_to_command("-W", $wordsize); }

if ( isset($cutoff_percent) && is_numeric($cutoff_percent) && ($cutoff_percent <= 100))
   { $blast_module->add_parameter_to_command("-p", $cutoff_percent); }

if ( isset($nr_descriptions) && is_numeric($nr_descriptions))
   { $blast_module->add_parameter_to_command("-v", $nr_descriptions); }

if ( isset($nr_alignments) && is_numeric($nr_alignments))
   { $blast_module->add_parameter_to_command("-b", $nr_alignments); }

if ( isset($ALIGNMENT_VIEW) )
   { $blast_module->add_parameter_to_command("-m", $ALIGNMENT_VIEW); }

if ( isset($OUTPUT_TYPE) )
   { $blast_module->add_parameter_to_command("-D", $OUTPUT_TYPE); }

if ( isset($OTHER_ADVANCED) )
   { $blast_module->add_parameter_to_command($OTHER_ADVANCED, ""); }

$blast_module->commit_job("");
// $blast_module->print_job_description();
$blast_module->print_html_footer();


?>

