#!/home/apache/clustercontrol/bin/php
<?php
# Verwendete Variablen
# Angabe der Position des HTML-Files, da zu Erstellung der Grafik geparsed wird.
# Angabe der Position des zu erstellenden .PNG-Files, in dem die Grafik gespeichert wird
# Angabe der Position des .PNG-Files, das die Zeichnung fr gewisse Alignments enthlt
# Angabe der Position des .TXT-Files, in das die Imagemap geschrieben wird.
#$filename	= "E:\BLAST Parser\Beispielseiten\TU (560)b.htm";
#$filename	= "E:\BLAST Parser\Beispielseiten\NCBI 2\Blast_htm2.htm";
#$filename	= "E:\PHP\Vom Cluster\output.htm";


if ($argc != 3) {
  echo "\nUSAGE: ".$argv[0]." <full path to inputfilename> <full path to php-ccontrol>\n\n";
  return (1);
}
else
{
  $filename=$argv[1];
  $image_file=$filename.".img.png";
  $map_file=$filename.".map.txt";
  $line_picture=$argv[2]."/png/line.png";
}

#	$image_file	= "Alignment.png";
#	$line_picture   = "Line.png";
#	$map_file       = "Map.txt";

if (!file_exists ($filename)) return (0);

# Informativere Grafikausgabe zum debuggen
	$Debuginfo     = 0;	# 1 fr Info, oder anderer Wert

# Image Size
	$with          = 536;
	# $height      		# wird weiter unten berechnet

#Image Border
	$left_space1   = 5;	# kann nach rechts versetzt werden. (Beim NCBI = 55)
	$left_space2   = 5;
	$right_space   = 5;

# Headline properties
	$font_size     = 3;
	$headline_x    = 168;
	$headline_y    = 5;
	$headline_text = "Color Key for Alignment Scores";

# Color Key Properties
	$box_y         = 20;
	$box_height    = 13;
	$no_of_boxes   = 5;
	$scalewith     = $with - $left_space1 - $right_space;
	$boxwith       = $scalewith / $no_of_boxes;
	$box1_text     = "<40";
	$box2_text     = "40-50";
	$box3_text     = "50-80";
	$box4_text     = "80-200";
	$box5_text     = ">=200";

# Seperator Line
	$line_y        = 36;

# Scale properties
	$scale_y       = 57;
	$scale_thick   = 5;
	$scale_min     = 0;
	# $scale_max 			liefert der Parser
	#$scale_small   = 20;		Abstand zwischen den kleinen Strichen - wird Berechnet 
	$seper_small_h = 5;
	#$scale_large   = 100;		Abstand zwischen den groen Strichen - wird Berechnet
	$seper_large_h = 9;
	$seper_y       = $scale_y + $scale_thick;

# Alignment Properties
	$Align_start_y = 100;
	$Align_thick   = 3;
	$Align_space   = 4;		# Abstand zwischen den Zeilen
	if ($Debuginfo == 1) $Align_space   = 10;
	$Align_dist    = 10;		# Abstand zwischen Alignments in der selben Zeile [Pixel]


# Die folgenden Variablen wurden auch noch verwendet:
#
# $fp			Filepointer
# $new_line 		Neue Zeile des $fp wird eingelesen
# $temp_var		Temporre Variable

# $SEQ_elements		Anzahl der Elemente in den $SEQ_...-Arrays
# $SEQ_now		Element, das jetzt gerade bearbeitet wird
# $SEQ_parts		ARRAY Anzahl der Bruchstcke pro Element
# $SEQ_p_now		Bruchstck, das jetzt gerade bearbeitet wird
# $SEQ_anchor		ARRAY Anker der Sequenz
# $SEQ_name		ARRAY Beschreibung der Sequenz
# $SEQ_score		ARRAY Score
# $SEQ_expect		ARRAY E-Value
# $SEQ_lenght		ARRAY Lnge
# $SEQ_start		ARRAY 2D Start of alignment in Query-Sequence 	[fr jedes Bruchstck]
# $SEQ_end		ARRAY 2D End of alignment in Query-Sequence 	[fr jedes Bruchstck]
# $SEQ_line		ARRAY Zeile, in der das Alignment gezeichnet wird
	
# $Line_Array   	Array, das beschreibt welche Pltze in Line schon belegt sind
# $smallest		kleinstes $SEQ_start von $seq_now
# $largest		grtes $SEQ_start von $seq_now
# $max_line_no		Anzahl an Lines [Anzahl der Zeilen in $Line_Array]
# $Line_Elements	ARRAY, Anzahl der Spalten in jeder Zeile von $Line_Array
# $SEQ_Line		ARRAY, Beschreibt in welcher Zeile die Sequenz gezeichnet wird

# $Space_found		TRUE wenn in den bisherigen Zeilen eine Lcke gefunden wurde




######################################################################
# PARSER fr die BLAST-HTML Ausgabe

      	$inputfile = file ($filename);		# Array, das $filename enthlt
      	$state = 0;				# Statusvariable
      						# 0: Ausgangszustand
      						# 1: "<b>Query=" gefunden. jetzt sollte kurz darauf "(xxx letters) folgen
      						# 2: "letters)" gefunden. (infos ber die Lnge der Query-Sequenz)
      						# 3: "Sequences producing significant alignments:" gefunden.
      						#    im Nchsten Absatz stehen die Anker-Namen der Sequenzen
      						#    der Absatz wird mit einem "</PRE>"-Tag abgeschlossen.
      						# 4: Einlesen des Beginns/ENdes des Alignments, des Alignment-Namen, etc...

      	
# Finde wieviel Letters die Query-Sequence Lang war
	foreach ($inputfile as $value)
	{
		#print "\n<br> $state ";
		
		switch ($state){
			case 0:
				if (strstr ($value, "<b>Query=")) {
					#print $value;
					$state = 1;
				}
				break;
			case 1:
				if (strstr ($value, "letters)")) {
					$state = 2;
     					$temp_var = sscanf (strstr ($value, "("), "\t(%d");
      					$scale_max = $temp_var[0];
      					#print $scale_max;
      				}
      				break;
      			case 2:
      				
      				if (strstr ($value, "Sequences producing significant alignments:")) {
      					$state = 3;
		      			$SEQ_now = 0;
      					#print $value;
      				}
      				break;

# Finde die Anker der verschiedenen Alignment-Sequences
	      	
	      		case 3:
	
				if (strstr ($value, "<a href = #")) {
      					$temp_var = sscanf (strstr ($value, '#'), '#%d >%d</a> %s');
      					$SEQ_anchor[$SEQ_now] = $temp_var[0];
      					$SEQ_score[$SEQ_now] = $temp_var[1];
      					$SEQ_expect[$SEQ_now] = trim ($temp_var[2]);
      					#print $SEQ_anchor[$SEQ_now] . " S=" . $SEQ_score[$SEQ_now] . "  E=" . $SEQ_expect[$SEQ_now];
      					$SEQ_now++;
      				}
      				

				if (strstr ($value, "</PRE>")) {
					$state = 4;

					$SEQ_elements = $SEQ_now - 1;
					$SEQ_now = -1;
					$SEQ_p_now = 0;
					$SEQ_start[$SEQ_p_now] = FALSE;
					$Last_String_containing_Query = FALSE;
				}
				break;
	

# Suche nach $SEQ_start[$SEQ_now][$SEQ_p_now]. Die Angabe befindet sich in der Ersten zeile die das Wort
# "Query" beinhaltet, nach dem jeweiligen Anker der Sequenz.
# Die Letzte Zeile vor einem "</PRE>"-Tag, die das Wort "Query" beinhaltet enthlt die Angabe ber das Ende
# des jeweiligen Elements vom Alignment ($SEQ_end[$SEQ_now][$SEQ_p_now]).
      	
      			case 4:
      			
      				if (strstr ($value, "Query:")) {				# Suche nach "Query"
					if (!$SEQ_start[$SEQ_now][$SEQ_p_now]) {			# Wenn noch kein START gefunden
						$tempvar = sscanf ($value, 'Query: %d');
						$SEQ_start[$SEQ_now][$SEQ_p_now] = intval ($tempvar[0]);
						#print "Start: " . $SEQ_start[$SEQ_now][$SEQ_p_now];
					}
					$Last_String_containing_Query = $value;
				}
				
				
				#if (strstr ($value, "Length =")) {
				#	$tempvar = sscanf (strstr ($value, "="), '= %s');
				#	$SEQ_length[$SEQ_now] = $tempvar[0];
				#	#print "Length " . $SEQ_length[$SEQ_now];
				#	
				#}
      		
      				if (strstr ($value, '</PRE>') && $Last_String_containing_Query) {	# Suche nach "</PRE>"
 					$SEQ_end[$SEQ_now][$SEQ_p_now] = intval(strrchr ($Last_String_containing_Query, ' ')) ;
					#print "End: " . $SEQ_end[$SEQ_now][$SEQ_p_now];
					$SEQ_p_now++;
					$SEQ_start[$SEQ_now][$SEQ_p_now] = FALSE;
					$Last_String_containing_Query = FALSE;
 				}
	
# Wenn der Anker der nchsten Sequenz in der Zeile vorkommt....
      				
      				if ($SEQ_now < $SEQ_elements) {
      					$tempvar = $SEQ_now + 1;
      			
      					if (strstr ($value, "a name = $SEQ_anchor[$tempvar]") && $state == 4) {		# Suche nach dem Anker der nchsten Sequenz
      						$SEQ_parts[$SEQ_now] = $SEQ_p_now - 1;
      						$SEQ_now++;
      						$SEQ_p_now = 0;
      						$SEQ_start[$SEQ_now][$SEQ_p_now] = FALSE;
						$SEQ_name[$SEQ_now] = strip_tags($value);
				}	}
				break;
			}	
      		}
	#############################
	# Eigentlich sollte man hier noch die Score und E-Value einlesen

	
	$SEQ_parts[$SEQ_now] = $SEQ_p_now - 1;
	$SEQ_elements = $SEQ_now;
	
	
	
     	


############################################################
# Berechnungen fr die Grafikausgabe

# Um den Platz in der Zeichnung besser zu ntzen werden mehrere Alignments in einer Zeile
# gezeichnet. Es wird ein Desciptor $SEQ_Line erstellt, der angibt in welcher Zeile die
# jeweilige Sequenz einzutragen ist

# $Line_Array   	Array, das beschreibt welche Pltze in Line schon belegt sind
# $smallest		Array kleinstes $SEQ_start von $seq_now
# $largest		Array grtes $SEQ_start von $seq_now
# $max_line_no		Anzahl an Lines [Anzahl der Zeilen in $Line_Array]
# $Line_Elements	ARRAY, Anzahl der Spalten in jeder Zeile von $Line_Array
# $SEQ_Line		ARRAY, Beschreibt in welcher Zeile die Sequenz gezeichnet wird

# $Space_found		TRUE wenn in den bisherigen Zeilen eine Lcke gefunden wurde

	$Align_dist = $Align_dist * $scale_max / $scalewith;

	$max_line_no = 0;
	$Line_Array[$max_line_no][0] = -5;		# left border
	$Line_Array[$max_line_no][1] = $scale_max + 5;	# right border
	$Line_Elements[$max_line_no] = 0;

	for ($SEQ_now = 0; $SEQ_now <= $SEQ_elements; $SEQ_now++){

# Finde die maximale Ausdehnung der Aligmnent Sequence 
# (von kleinstem $SEQ_start[$SEQ_now] bis zum grten $SEQ_end[$SEQ_now]
	$largest[$SEQ_now] = max ($SEQ_end[$SEQ_now]);		# "max" funktioniert...
	
	$smallest[$SEQ_now] = $SEQ_start[$SEQ_now][0];		# ... aber aus irgendeinem Grund funkt "min" nicht.
	for ($i = 1; $i <= $SEQ_parts[$SEQ_now]; $i++) {
		if ($SEQ_start[$SEQ_now][$i] < $smallest[$SEQ_now]) $smallest[$SEQ_now] = $SEQ_start[$SEQ_now][$i];
	}
	
		
# Find FREE LINE
		$Space_found = FALSE;		
		for ($i = 0; $i <= $max_line_no; $i++) {
			for ($j = 0; $j <= $Line_Elements[$i]; $j++) {
    # Wenn Lcke gefunden			
				if (($Line_Array[$i][$j * 2] + $Align_dist < $smallest[$SEQ_now]) && ($Line_Array[$i][($j * 2) + 1] - $Align_dist > $largest[$SEQ_now])){
    # Erweitere $Line_Array[$i]				
					for ($k = $Line_Elements[$i]; $k >= $j; $k--) {
						$Line_Array[$i][($k * 2) + 3] = $Line_Array[$i][($k * 2) + 1];
						$Line_Array[$i][($k * 2) + 2] = $Line_Array[$i][($k * 2)];
					}
					$Line_Elements[$i]++;
					$Line_Array[$i][($j * 2) + 1] =  $smallest[$SEQ_now];
					$Line_Array[$i][($j * 2) + 2] =  $largest[$SEQ_now];
					$SEQ_Line[$SEQ_now] = $i;
					$Space_found = TRUE;
					break;
			}	}
			if ($Space_found == TRUE) break;	
		}
	
     # Wenn KEINE Lcke gefunden wurde...
		if ($Space_found == FALSE) {
			
			$max_line_no++;
			$Line_Array[$max_line_no][0] = -5;		# left border
			$Line_Array[$max_line_no][1] = $smallest[$SEQ_now];
			$Line_Array[$max_line_no][2] = $largest[$SEQ_now];
			$Line_Array[$max_line_no][3] = $scale_max + 5;	# right border
			$Line_Elements[$max_line_no] = 1;
			$SEQ_Line[$SEQ_now] = $max_line_no;
		}
		if ($Debuginfo == 1) $SEQ_Line[$SEQ_now] = $SEQ_now;
	}
	if ($Debuginfo == 1) $max_line_no = $SEQ_elements;

# Berechnen der Variablen
	$height = $Align_start_y + ( $Align_thick + $Align_space) * ($max_line_no + 1);
	$tempvar1 = 1;
	while (1 == 1) 
	{
		if ($scale_max / $tempvar1 <= 1) break;
		$tempvar1 = $tempvar1 * 10;
	}
	
	if ($scale_max / $tempvar1 <= 0.5) {
		$scale_large = $tempvar1 / 20;
	} else {
		$scale_large = $tempvar1 / 10;
	}
	
	$scale_small = $scale_large / 5;
	$seper_small_no = (($scale_max - $scale_min) / $scale_small);
	$seper_large_no = ($scale_max - $scale_min) / $scale_large;


####################################################################	
# Start Drawing

#	header ("Content-type: image/png");
	$fp2 = fopen ($map_file, "wb");
	$Image2 = ImageCreateFromPNG($line_picture);


	$im = ImageCreate ($with, $height)
	    or die ("Cannot Initialize new GD image stream");

	$background_color = ImageColorAllocate ($im, 255,255,255);
	$text_color       = ImageColorAllocate ($im,   0,  0,  0);
	$red              = ImageColorAllocate ($im, 255,  0,  0);
	$green            = ImageColorAllocate ($im,   0,255,  0);
	$blue             = ImageColorAllocate ($im,   0,  0,255);
	$magenta          = ImageColorAllocate ($im, 255,  0,255);
	$black            = ImageColorAllocate ($im,   0,  0,  0);
	$yellow           = ImageColorAllocate ($im, 255,255,  0);
	$gray             = ImageColorAllocate ($im, 200,200,200);

# Draw Headline
	ImageString ($im, $font_size, $headline_x, $headline_y,  $headline_text, $text_color);

# Draw Color Key
	$x1 = $left_space1;
	$x2 = $x1 + $boxwith;

	for ($i = 1; $i <= $no_of_boxes; $i++) {
	    
	    switch ($i) {
    		case 1:    
    			ImageFilledRectangle($im, $x1, $box_y, $x2, $box_y + $box_height, $black);
    			ImageString ($im, $font_size, $x1+ $with / 12, $box_y,  $box1_text, $background_color);
	    		break;
    		case 2:    
    			ImageFilledRectangle($im, $x1, $box_y, $x2, $box_y + $box_height, $blue);
	    		ImageString ($im, $font_size, $x1+ $with / 15, $box_y,  $box2_text, $background_color);
	    		break;
    		case 3:    
    			ImageFilledRectangle($im, $x1, $box_y, $x2, $box_y + $box_height, $green);
	    		ImageString ($im, $font_size, $x1+ $with / 15, $box_y,  $box3_text, $text_color);
	    		break;
    		case 4:    
    			ImageFilledRectangle($im, $x1, $box_y, $x2, $box_y + $box_height, $magenta);
	    		ImageString ($im, $font_size, $x1+ $with / 15, $box_y,  $box4_text, $text_color);
	    		break;
    		case 5:    
    			ImageFilledRectangle($im, $x1, $box_y, $x2, $box_y + $box_height, $red);
	    		ImageString ($im, $font_size, $x1+ $with / 15, $box_y,  $box5_text, $text_color);
	    		break;
	    }
	    $x1 = $x2;
	    $x2 = $x1 + $boxwith;    
	}

# Draw Seperator Line
	ImageLine   ($im, $left_space2, $line_y, $with - $right_space, $line_y, $black);
	if ($Debuginfo == 1) ImageString ($im, $font_size, $left_space2, $line_y + 2, "Segment: p_now/Parts", $blue);

# Draw Scale
	ImageFilledRectangle($im, $left_space1, $scale_y, $with - $right_space, $scale_y + $scale_thick, $red);

   # Small Seperators
	$x1 = $left_space1;
	$s  = ( $with - $left_space1 - $right_space ) / $seper_small_no;
	for ($i = 1; $i <= $seper_small_no + 1; $i++) {
	     	ImageLine   ($im, $x1, $seper_y, $x1, $seper_y + $seper_small_h, $black);
		$x1 = $x1 + $s;
	}

   # Large Seperators
	$x1 = $left_space1;
	$s  = ( $with - $left_space1 - $right_space ) / $seper_large_no;
	for ($i = 1; $i <= $seper_large_no + 1; $i++) {
	     	ImageLine   ($im, $x1, $seper_y, $x1, $seper_y + $seper_large_h, $black);
	     	$temp_var = $x1 - 10;
	     	if ($i == 1) $temp_var = $x1;
	     	if (($with - $x1) <= 20) $temp_var = $x1 - 20;
		ImageString ($im, $font_size, $temp_var, $seper_y + $seper_large_h,  ($i - 1) * $scale_large, $text_color);
		$x1 = $x1 + $s;
	}
	
	

# Zeichnen der Alignments		
	
	fwrite ($fp2, "<map name=\"Alignment_Map\">");
	for ($SEQ_now = 0; $SEQ_now <= $SEQ_elements; $SEQ_now++){

		$y1 = intval($Align_start_y + ($SEQ_Line[$SEQ_now] * ($Align_space + $Align_thick)));
		$y2 = intval($y1 + $Align_thick);
		$x1 = intval($left_space1 + ($smallest[$SEQ_now]) * $scalewith / $scale_max);
		$x2 = intval($left_space1 + ($largest[$SEQ_now])  * $scalewith / $scale_max);
		if ($Debuginfo == 1) ImageRectangle($im, $x1-1, $y1-1, $x2+1, $y2+1, $yellow);
		
# Schreiben der Image-Map
		fwrite ($fp2, "<area shape=\"rect\" coords=\"$x1, $y1, $x2, $y2\" ");
		fwrite ($fp2, " href=\"#" . $SEQ_anchor[$SEQ_now]. "\" ONMOUSEOVER='document.forms[0].defline.value=\"" . rtrim($SEQ_name[$SEQ_now]) . "\"'");
		fwrite ($fp2, " ONMOUSEOUT='document.forms[0].defline.value=\"Mouse-over to show defline and scores. Click to show alignments\"'");
		fwrite ($fp2, " alt=\"" . rtrim($SEQ_name[$SEQ_now]) . "\">");
# Wenn mehrere Parts existieren, zeichne die Schraffierte Flche		
		if ( $SEQ_parts[$SEQ_now] != 0) {	
			ImageCopy($im, $Image2, $x1, $y1, 1, 0, $x2 - $x1, $Align_thick + 1);
		}

		$temp_var = $largest[$SEQ_now] - $smallest[$SEQ_now];
		if  ($temp_var < 40)  { 
			$color = $black;
    		} elseif ($temp_var < 50) {   
			$color = $blue;
    		} elseif ($temp_var < 80) {   
			$color = $green;
   		} elseif ($temp_var < 200) {   
			$color = $magenta;
    		} else {    
			$color = $red;
		}

# Zeichne die einzelnen Parts
		for ($SEQ_p_now = 0; $SEQ_p_now <= $SEQ_parts[$SEQ_now]; $SEQ_p_now++){
			

			$x1 = intval($left_space1 + ($SEQ_start[$SEQ_now][$SEQ_p_now]) * $scalewith / $scale_max);
			$x2 = intval($left_space1 + ($SEQ_end[$SEQ_now][$SEQ_p_now])   * $scalewith / $scale_max);
			
			ImageFilledRectangle($im, $x1, $y1, $x2, $y2, $color);
			if ($Debuginfo == 1) ImageString   ($im, $font_size, $x1 , $Align_start_y + ($SEQ_Line[$SEQ_now] * ($Align_space + $Align_thick)), "$SEQ_now: $SEQ_p_now/$SEQ_parts[$SEQ_now]" , $blue);
		}
	}
	fwrite ($fp2, "</map>");
	
# FINISH Drawing Image
	ImagePNG ($im,$image_file);	# Schreibe PNG als File
	ImageDestroy($im);		# Schreibe PNG als File
#	ImagePNG ($im);			# PNG als Ausgabe (Achtung: Wenn aktiviert auch den entsprechenden Header
					#			in "Start Drawing" ausgeben!)
	fclose ($fp2);
	
	
?>
H