<?php
   require_once ("../../inc/lib_include_modules.php");
   
   $program=$_POST['program'];
   $jobname=$_POST['jobname'];
   $searchdatabases=$_POST['searchdatabases'];   
   $expectationvalue=$_POST['expectationvalue'];


   $wordsize=$_POST['wordsize'];
   $nr_descriptions=$_POST['nr_descriptions'];
   $nr_alignments=$_POST['nr_alignments'];
   $gap_opening_penalty=$_POST['gap_opening_penalty'];
   $gap_extension_penalty=$_POST['gap_extension_penalty'];
   $nucleic_mismatch=$_POST['nucleic_mismatch'];
   $nucleic_match=$_POST['nucleic_match'];
   $extension_treshold=$_POST['extension_treshold'];
   $matrix=$_POST['matrix'];
   
   $factory=new run_module_class_factory();
   $blast_module=$factory->createRunModuleClass($_SESSION['PHP_AUTH_USER'], $program, $jobname);
   $blast_module->print_html_header();   

   $Matrices=new matrix_class("");
   $blast_module->process_databases($searchdatabases);
   $blast_module->process_sequence_input( 'sequence', $_POST, 'sequence_file', $_FILES );


   $blast_module->add_parameter_to_command("-i", "%Inputfile");
   $blast_module->add_parameter_to_command("-d", "%Database");

   if ( isset($expectationvalue) && is_numeric($expectationvalue)) 
      { $blast_module->add_parameter_to_command("-e", $expectationvalue); }

   if ( isset($wordsize) && is_numeric($wordsize))
      { $blast_module->add_parameter_to_command("-W", $wordsize); }

   if ( isset($nr_descriptions) && is_numeric($nr_descriptions))
      { $blast_module->add_parameter_to_command("-v", $nr_descriptions); }

   if ( isset($nr_alignments) && is_numeric($nr_alignments))
      { $blast_module->add_parameter_to_command("-b", $nr_alignments); }

   if ( isset($gap_opening_penalty) && is_numeric($gap_opening_penalty))
      { $blast_module->add_parameter_to_command("-G", $gap_opening_penalty); }

   if ( isset($gap_extension_penalty) && is_numeric($gap_extension_penalty))
      { $blast_module->add_parameter_to_command("-E", $gap_extension_penalty); }

   if ( isset($gapped_alignment) && is_numeric($gapped_alignment) && ($gapped_alignment==1))
      { $blast_module->add_parameter_to_command("-g", "F"); }

   if ( isset($nucleic_mismatch) && is_numeric($nucleic_mismatch))
         { $blast_module->add_parameter_to_command("-q", $nucleic_mismatch); }

   if ( isset($nucleic_match) && is_numeric($nucleic_match))
         { $blast_module->add_parameter_to_command("-r", $nucleic_match); }

   if ( isset($extension_treshold) && is_numeric($extension_treshold))
      { $blast_module->add_parameter_to_command("-f", $extension_treshold); }

   if ( isset($matrix) && is_string($matrix) && (strcmp($matrix,"Default")!=0))
      { 
        $blast_module->add_parameter_to_command("-M", $matrix); 
      }
      
   $blast_module->set_postprocessing_command("/home/apache/clustercontrol/bin/alignment.php");
   $blast_module->add_parameter_to_postprocessing_command("", "%Outputfile");
   $blast_module->add_parameter_to_postprocessing_command("", "/home/apache/clustercontrol");

   $blast_module->commit_job(""); 
//   $blast_module->print_job_description();
   $blast_module->print_html_footer();
/*
       <td>Reporting Treshold: </td> <td><input name="reporting_treshold" type="text" size="7" maxlength="7" value="1"> </td>
*/
?>
